try {var geckotip = Components.classes["@geckotip.mozdev.org/geckotip/fx18;1"].getService(Components.interfaces.iGeckotip);} 
catch(err) { alert(document.getElementById("bundle_geckotip").getString(errmsg) + err); }

var tipPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService);
var tipPref = tipPrefService.getBranch("geckotip.");
var tipCoerce = tipPref.getBoolPref("scopingon");
var tipLastDesc, tipCurrentScopes;
//var th=false;

function tipBlur()
{
	document.getElementById("geckotip-panel-label").value = (tipCoerce?"":"(") + "None" + (tipCoerce?"":")");
	geckotip.unfocused();
}

function tipDebugPrint()
{
	alert("Scopes: " + tipCurrentScopes + "\nDescriptor: " + tipLastDesc);
}

function tipToggleInk()
{	
	tipCoerce = !tipCoerce;
	try { document.commandDispatcher.focusedElement.blur(); } catch(e) { }
	tipBlur();
}

function tipSetRecog(s) 
{
	//var x = document.commandDispatcher.focusedElement;
	//if (!x) return; tn = x.tagName;
	//if ((tn!="html:input")&&(tn!="TEXTAREA")&&(tn!="INPUT")) return;
	tipSetScope(s,false); 
	//th=true; 
	//x.blur(); 
	//x.focus();
	//th=true; 
	//x.setSelectionRange(x.selectionEnd,x.selectionEnd);
}

function tipElementDescriptor(e)
{
	var gotID=false, gotName=false, desc="";//fe.ownerDocument.location.href

	while ( (e.getAttribute) && ((!gotID)||(!gotName)) )
	{
		if ((!gotID)&&(e.getAttribute("id"))) {
			gotID = true;
			desc=desc + "i[" + e.getAttribute("id") + "] l[" + label_for(e.getAttribute("id")) + "] ";			
		}
		if ((!gotName)&&(e.getAttribute("name"))) {
			gotName = true;
			desc=desc + "n[" + e.getAttribute("name") + "] ";			
		}
		try { e=e.parentNode; } catch(e) { return desc; }
	}
	return desc;
}

function label_for(id)
{
	var labels = document.getElementsByTagName("label");
	for (var i=0;i<labels.length;i++) 
		if (labels[i].htmlFor) 		
			if (labels[i].htmlFor==id)  return labels[i].textContent;
	return "";
}

function tipFocus()
{
	var scopeSettled=false;
	var fe = document.commandDispatcher.focusedElement;

	if (fe==null) {	tipBlur(); return; }
	geckotip.focused();
	var tn = fe.tagName;
	var type = fe.getAttribute("type");
	if (type) type = type.toLowerCase();

	tipSetScope(IS_DEFAULT);
	tipLastDesc = "N/A"; tipCurrentScopes = "Anything";	//debug
	if ((tn!="html:input")&&(tn!="TEXTAREA")&&(tn!="INPUT")) { tipBlur(); return; }
	if (tn=="INPUT") {
		if (type=="password")
			{ tipSetScope(IS_PASSWORD); scopeSettled=true; }
		else if (type=="file")
			{ tipSetScope(IS_FILE_FULLFILEPATH); scopeSettled=true; }
		else if (type=="text" || type==null)
		{
			// it might be the anonymous child of a file input
			if (fe.parentNode.tagName == "INPUT")
			{
				var pt = fe.parentNode.type;
				if (pt) pt = pt.toUpperCase();
				if (pt=="FILE")
				{
					tipSetScope(IS_FILE_FULLFILEPATH); scopeSettled=true;
				}
			}
		}
	}
	if (!scopeSettled) {
		var desc = tipElementDescriptor(fe);
		if (desc) desc=desc.toLowerCase(); 
		tipLastDesc=desc; //debug
		var i, re, firstScope=true;
	
		for (i=0; i < tipMatches.length; i++) 
		{
			if (desc.search(tipMatches[i].pattern) != -1) {
				if (firstScope) { 
					tipSetScope(tipMatches[i].code,false); 
					firstScope = false; 
				} else { 
					tipSetScope(tipMatches[i].code,true); 
				}
			}
		}
	}
}

function tipSetScope(s, add) 
{
	var bx = document.getElementById("geckotip-panel-label");
	var tipBundle = document.getElementById("bundle_geckotip");
	
	if (add) {
		if (tipCoerce) geckotip.addScope(s);
		tipCurrentScopes = tipCurrentScopes + ", " + tipBundle.getString("tipScope" + s);
	} else {
		if (tipCoerce) geckotip.setScope(s);
		tipCurrentScopes = tipBundle.getString("tipScope" + s);
	}
	bx.value = tipCurrentScopes;
	if (!tipCoerce) {
		geckotip.setScope(IS_DEFAULT);
		bx.value = "(" + bx.value + ")";
	}
}

function tipDebug()
{
	geckotip.toggleDebug();
}


function tipFlashXUL()
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return; 
	if (x.tagName == "html:input") {
		x.setSelectionRange(x.selectionEnd,x.selectionEnd);
	}
	return true;
}

function tipSendEnter() 
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return;
	var ev = document.createEvent("KeyEvents");
	ev.initKeyEvent("keypress", true, true, window, false, false, false, false, 13, 13);
	x.dispatchEvent(ev); 
}

window.addEventListener("blur",tipBlur,true);
window.addEventListener("focus",tipFocus,true);
window.addEventListener("dblclick",tipDebug,true);  //DEBUG
window.addEventListener("input",tipFlashXUL,false);  // necessary to fix Firefox caret tracking bug in XUL textboxes
